## mhash 384.2018-02-07.sources

=== Makefile ===
SHELL = /bin/bash

#############################################################################
# BUILD OPTIONS
#############################################################################

CPLUSPLUS ?= 0
WITH_JAVA ?= 1

CPU_ARCH ?= native
CPU_TUNE ?= generic

HOME ?= /tmp

#############################################################################
# CONFIGURATION
#############################################################################

ifdef ARCH
  CM_FLAGS += $(if $(filter x64,$(ARCH)),-m64,-m32)
else
  ARCH := $(if $(findstring x86_64,$(shell $(CXX) -v 2>&1 | grep "Target:")),x64,x86)
endif

ifeq ($(OS),Windows_NT)
  OSTYPE := mingw
  JNIDIR := win32
  BINEXT := .exe
  DLLEXT := .dll
  DLLOPT := -shared
else
  OSTYPE := linux
  JNIDIR := linux
  BINEXT := .run
  DLLEXT := .so
  DLLOPT := -fPIC -shared
endif

ROOT_DIR := $(dir $(realpath $(lastword $(MAKEFILE_LIST))))
WORK_DIR := /tmp/$(shell head /dev/urandom | tr -dc A-Za-z0-9 | head -c 12)
JARS_DIR := $(HOME)/.jar
ISO_DATE := $(shell date "+%Y-%m-%d")

CM_FLAGS := -I$(ROOT_DIR)/include
RL_FLAGS := -DNDEBUG -O3 -march=$(CPU_ARCH) -mtune=$(CPU_TUNE)
DB_FLAGS := -g
EX_FLAGS := -static
SO_FLAGS := $(DLLOPT) -static-libgcc -static-libstdc++
PD_FLAGS := --from markdown_github+pandoc_title_block+header_attributes+implicit_figures --to html5 --toc -N --standalone -H "etc/css/style.inc"

#############################################################################
# FILE NAMES
#############################################################################

TXT := $(ROOT_DIR)COPYING.txt
DOC := $(ROOT_DIR)README.html 
JPG := $(wildcard $(ROOT_DIR)/img/mhash/*.jpg)

ifeq ($(CPLUSPLUS),1)
  CLI_CXX := g++
  CLI_SRC := $(wildcard $(ROOT_DIR)/src/*.cpp)
else
  CLI_CXX := gcc
  CLI_SRC := $(wildcard $(ROOT_DIR)/src/*.c)
endif

CLI_BIN := $(ROOT_DIR)bin/mhash_384.$(ARCH)$(BINEXT)
CLI_DBG := $(ROOT_DIR)bin/mhash_384_g.$(ARCH)$(BINEXT)
CLI_OUT := $(ROOT_DIR)out/mhash_384.$(ISO_DATE).$(OSTYPE)-$(ARCH).tar.gz

JAV_JAR := $(ROOT_DIR)bindings/Java/library/out/MHashJava384.jar
JAV_GUI := $(ROOT_DIR)bindings/Java/example/out/MHashJava384-Example.jar
JAV_OUT := $(ROOT_DIR)out/mhash_384.$(ISO_DATE).java.tar.gz

PYT_LIB := $(ROOT_DIR)bindings/Python/library/MHashPy384.py
PYT_GUI := $(ROOT_DIR)bindings/Python/example/MHashPy384_Example.py
PYT_BIN := $(ROOT_DIR)bindings/Python/native/bin/MHashPy384_Native.$(ARCH)$(PYDEXT)
PYT_OUT := $(ROOT_DIR)out/mhash_384.$(ISO_DATE).python.tar.gz


#############################################################################
# TARGETS
#############################################################################

TARGETS = $(CLI_OUT) $(PYT_OUT)

ifeq ($(WITH_JAVA),1)
  TARGETS += $(JAV_OUT)
endif


#############################################################################
# MAKE RULES
#############################################################################

.PHONY: all clean

all: $(TARGETS)

# -----------------------------------------------
# PACKAGE
# -----------------------------------------------

$(CLI_OUT): $(CLI_BIN) $(CLI_DBG) $(DOC) $(TXT)
	rm -rfv $@ $(WORK_DIR)
	mkdir -p $(dir $@) $(WORK_DIR)/img/mhash
	cp $(JPG) $(WORK_DIR)/img/mhash
	cp $(DOC) $(TXT) $(CLI_BIN) $(WORK_DIR)
	pushd $(WORK_DIR) && tar -czf $@ *
	rm -rfv $(WORK_DIR)

$(JAV_OUT): $(JAV_JAR) $(JAV_GUI) $(DOC) $(TXT)
	rm -rfv $@ $(WORK_DIR)
	mkdir -p $(dir $@) $(WORK_DIR)/img/mhash
	cp $(JPG) $(WORK_DIR)/img/mhash
	cp $(DOC) $(TXT) $(JAV_JAR) $(JAV_GUI) $(WORK_DIR)
	pushd $(WORK_DIR) && tar -czf $@ *
	rm -rfv $(WORK_DIR)

$(PYT_OUT): $(PYT_LIB) $(PYT_GUI) $(DOC) $(TXT)
	rm -rfv $@ $(WORK_DIR)
	mkdir -p $(dir $@) $(WORK_DIR)/img/mhash
	cp $(JPG) $(WORK_DIR)/img/mhash
	cp $(DOC) $(TXT) $(PYT_LIB) $(PYT_GUI) $(WORK_DIR)
	pushd $(WORK_DIR) && tar -czf $@ *
	rm -rfv $(WORK_DIR)

# -----------------------------------------------
# COMPILE
# -----------------------------------------------

$(CLI_BIN): $(CLI_SRC)
	mkdir -p $(dir $@)
	$(CLI_CXX) $(CM_FLAGS) $(EX_FLAGS) $(RL_FLAGS) -o $@ $^
	strip -s $@

$(CLI_DBG): $(CLI_SRC)
	mkdir -p $(dir $@)
	$(CLI_CXX) $(CM_FLAGS) $(EX_FLAGS) $(DB_FLAGS) -o $@ $^

$(JAV_JAR): $(abspath $(dir $(JAV_JAR))/../build.xml)
	mkdir -p $(dir $@)
	pushd $(dir $^) && ant clean jar

$(JAV_GUI): $(abspath $(dir $(JAV_GUI))/../build.xml)
	mkdir -p $(dir $@)
	pushd $(dir $^) && ant clean jar

# -----------------------------------------------
# DOCUMENTS
# -----------------------------------------------

%.html: %.md
	mkdir -p $(JARS_DIR)
	wget -N -P $(JARS_DIR) https://repo1.maven.org/maven2/com/yahoo/platform/yui/yuicompressor/2.4.8/yuicompressor-2.4.8.jar
	wget -N -P $(JARS_DIR) https://repo1.maven.org/maven2/com/googlecode/htmlcompressor/htmlcompressor/1.5.2/htmlcompressor-1.5.2.jar
	pandoc $(PD_FLAGS) $^ | java -jar $(JARS_DIR)/htmlcompressor-1.5.2.jar --compress-css -o $@

# -----------------------------------------------
# CLEAN UP
# -----------------------------------------------

clean:
	rm -fv $(CLI_BIN) $(CLI_DBG) $(CLI_OUT)
	rm -fv $(JAV_BIN) $(JAV_JAR) $(JAV_GUI) $(JAV_OUT)
	rm -fv $(PYT_BIN) $(PYT_OUT)
	rm -fv $(DOC)

## mhash 0.9.9.9

=== debian/changelog ===
mhash (0.9.9.9-4) unstable; urgency=low

  * disable multi-arch for -dev package (closes: #723667)
  * minor autotools patches

 -- Barak A. Pearlmutter <bap@debian.org>  Fri, 18 Oct 2013 19:33:51 +0100

mhash (0.9.9.9-3) unstable; urgency=low

  * turn on multi-arch: same to allow co-existence
  * stop using dh-exec (see http://wiki.debian.org/Multiarch/Implementation)

 -- Barak A. Pearlmutter <bap@debian.org>  Tue, 25 Jun 2013 14:13:58 +0100

mhash (0.9.9.9-2) unstable; urgency=low

  * debian/control:
    - add VCS field (collab-maint git repo)
    - add homepage field
    - bump standards version
    - add self as co-maintainer
  * Move to dh9, update packaging scripts accordingly
  * Use dh-autoreconf
  * Support multiarch using dh-exec
  * Switch to dpkg source format 3.0 (quilt)
  * Incorporate Fedora patches (closes: #649092)
  * Patch a spelling error

 -- Barak A. Pearlmutter <bap@debian.org>  Tue, 25 Jun 2013 09:43:43 +0100

mhash (0.9.9.9-1.1) unstable; urgency=low

  * NMU
  * lib/{whirlpool,snefru}.c: Fix mhash_deinit segfaults when digest is NULL

 -- Chow Loong Jin <hyperair@debian.org>  Mon, 09 Jan 2012 20:32:32 +0800

mhash (0.9.9.9-1) unstable; urgency=low

  * New upstream version.
  * include/mutils/mhash_config.h.in: Remove PACKAGE_ variables from
    include file.  (closes: Bug#473204)
  * include/mutils/mhash.h: Manually patch mhash_get_hash_name to return
    "char *".  (closes: Bug#354206)
  * debian/control: Bump standards-version to 3.8.3 (no changes).
  * Remove unused maintainer scripts.
  * debian/control, debian/compat: Use debhelper version 5.

 -- Chris Hanson <cph@debian.org>  Wed, 02 Dec 2009 02:56:36 -0800

mhash (0.9.9-1) unstable; urgency=low

  * New upstream version.
    - No longer contains non-free RFCs.  (closes: Bug#393398)
  * debian/rules: eliminate lintian warning
    debian-rules-ignores-make-clean-error.
  * debian/control: eliminate lintial error
    not-binnmuable-any-depends-any.

 -- Chris Hanson <cph@debian.org>  Sat, 21 Jul 2007 22:15:39 -0400

mhash (0.9.7.dfsg-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Pruning rfc's from the source package (Closes: 393398).

 -- Pierre Habouzit <madcoder@debian.org>  Sat, 21 Jul 2007 15:19:31 +0200

mhash (0.9.7-1) unstable; urgency=low

  * New upstream version.

 -- Chris Hanson <cph@debian.org>  Sun, 25 Jun 2006 21:49:23 -0400

mhash (0.9.6-3) unstable; urgency=low

  * Fix VERSION problem by renaming that variable to MHASH_VERSION.
    (closes: Bug#356490)

 -- Chris Hanson <cph@debian.org>  Wed, 31 May 2006 14:55:40 -0400

mhash (0.9.6-2) unstable; urgency=low

  * Attempt to fix #350088.  This patch looks correct when compared to
    version 0.9.1, so please test and report back to BTS.
  * debian/rules: Define MHASH_ROBUST when making package; this should
    convert segfaults (e.g. from #350088) into errors.
  * Considerably complicate patch to <mhash.h> in order to fix problems
    caused by previous patch.
  * Patch upstream typos in several files.
  * Bump standards-version to 3.7.2 (no changes).

 -- Chris Hanson <cph@debian.org>  Sun, 14 May 2006 01:03:43 -0400

mhash (0.9.6-1) unstable; urgency=low

  * New upstream version.  The last release opened several bugs (348604
    354206 350088) against this package, which remain open upstream.
    Please test and report the results back to BTS, as upstream needs to
    hear from us.  (Thanks to Marc Haber for forwarding the bug reports
    upstream -- I've been swamped with work and am having trouble keeping
    up.)
  * Patch <mhash.h> to work around problem with VERSION.  Fixes #356490,
    but the bug remains open.  I will reduce its severity until it is
    fixed upstream.

 -- Chris Hanson <cph@debian.org>  Tue, 21 Mar 2006 00:32:06 -0500

mhash (0.9.4a-1) unstable; urgency=low

  * New upstream version.  (closes: Bug#342678)
  * patch upstream version: restore missing include file.
  * debian/copyright: update FSF address.
  * debian/control: bump standards-version (no changes).
  * debian/libmhash-dev.files: make sure all include files are moved.

 -- Chris Hanson <cph@debian.org>  Fri, 13 Jan 2006 23:24:34 -0500

mhash (0.9.1-1) unstable; urgency=low

  * New upstream version.  (closes: Bug#263093)
  * Don't rebuild autoconf files to get static libraries.  Just pass args
    to configure script.

 -- Chris Hanson <cph@debian.org>  Tue, 30 Nov 2004 00:25:59 -0500

mhash (0.8.18-4) unstable; urgency=low

  * Bump version to work around failed upload.

 -- Chris Hanson <cph@debian.org>  Tue, 16 Dec 2003 14:29:11 -0500

mhash (0.8.18-2) unstable; urgency=low

  * Put libmhash.a back.  (closes: Bug#221797, Bug#222826)

 -- Chris Hanson <cph@debian.org>  Tue, 16 Dec 2003 12:54:36 -0500

mhash (0.8.18-1) unstable; urgency=low

  * New upstream version.  (Well, not so new really.)
  * Remove libmhash.a since it is no longer built by upstream.
  * Standards version 3.6.1 (no changes).

 -- Chris Hanson <cph@debian.org>  Fri, 31 Oct 2003 23:37:39 -0500

mhash (0.8.17-1) unstable; urgency=low

  * New upstream version.
  * Eliminate reference to dh_undocumented.
  * Use dh_installman rather than dh_installmanpages.
  * Add ${misc:Depends} reference.
  * Change section of libapm-dev to libdevel.
  * Eliminate unneeded local variables in debian/changelog.
  * Add support for "noopt" in DEB_BUILD_OPTIONS.
  * Change standards version to 3.5.9.
  * Update debian/rules according to latest advice from autotools-dev.

 -- Chris Hanson <cph@debian.org>  Tue, 1 Apr 2003 23:48:37 -0500

mhash (0.8.16-1) unstable; urgency=low

  * New upstream version.

 -- Chris Hanson <cph@debian.org>  Thu, 30 May 2002 16:37:07 -0400

mhash (0.8.14-1) unstable; urgency=low

  * New upstream version.

 -- Chris Hanson <cph@debian.org>  Fri, 29 Mar 2002 11:24:22 -0500

mhash (0.8.13-1) unstable; urgency=low

  * New upstream version.

 -- Chris Hanson <cph@debian.org>  Sun, 18 Nov 2001 23:27:05 -0500

mhash (0.8.12-1) unstable; urgency=low



=== debian/control ===
Source: mhash
Section: libs
Priority: optional
Maintainer: Chris Hanson <cph@debian.org>
Uploaders: Barak A. Pearlmutter <bap@debian.org>
Build-Depends: debhelper (>= 9), dh-autoreconf
Standards-Version: 3.9.4
Homepage: http://mhash.sourceforge.net/
Vcs-Git: git://anonscm.debian.org/collab-maint/mhash.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/mhash.git

Package: libmhash2
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library for cryptographic hashing and message authentication
 Mhash is a library that provides a uniform interface to a large
 number of hash algorithms.  These algorithms can be used to compute
 checksums, message digests, and other signatures.  The HMAC support
 implements the basics for message authentication, following RFC 2104.
 Mhash also provides several key-generation algorithms, including
 those of OpenPGP (RFC 2440).
 .
 This package contains the shared library.

Package: libmhash-dev
Section: libdevel
Architecture: any
Depends: libmhash2 (= ${binary:Version}), libc6-dev, ${misc:Depends}
Description: Library for cryptographic hashing and message authentication
 Mhash is a library that provides a uniform interface to a large
 number of hash algorithms.  These algorithms can be used to compute
 checksums, message digests, and other signatures.  The HMAC support
 implements the basics for message authentication, following RFC 2104.
 Mhash also provides several key-generation algorithms, including
 those of OpenPGP (RFC 2440).  Further information is available at
 http://mhash.sourceforge.net/.
 .
 This package contains header files, the man page, and the static
 library.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --parallel --with autoreconf

export CPPFLAGS += -DMHASH_ROBUST

override_dh_installchangelogs:
	dh_installchangelogs NEWS

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg\d*$//,uversionmangle=s/_/./g;s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|b|a)[\-\.]?\d*)$/$1~$2/ \
http://qa.debian.org/watch/sf.php/mhash/mhash-(\d.*)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))
# Bart Martens <bartm@debian.org>  Sun, 06 Jan 2013 21:11:46 +0000
